-- vvv test template -- avoid on_init/on_config headache
script.on_nth_tick(68, DoRunOnce)

function SetArmour(player)
	log("SetArmour(): " .. player.name)
	local equipment = {}
	equipment["fusion-reactor-equipment"] = 4
	equipment["battery-mk2-equipment"] = 8
	equipment["personal-roboport-equipment"] = 5
	
	player.insert{ name = "construction-robot", count = 50 }
		
	player.get_inventory(defines.inventory.character_armor).clear()
	player.insert{name="power-armor-mk2", count = 1}
	local grid = player.get_inventory(defines.inventory.character_armor)[1].grid
	for k, v in pairs(equipment) do
		for c = 1, v do
			grid.put({ name = k })
		end
	end	
	
end

function DoRunOnce(event)
	log("DoRunOnce()")
	
	global.TestTemplate = global.TestTemplate or {}
	
	-- New game
	if not global.TestTemplate.GameInited then
		for i, player in pairs(game.players) do
			if player.valid then
				SetArmour(player)
				player.cheat_mode = true
			end
		end
		for index, force in pairs(game.forces) do
			force.research_all_technologies()
		end
		
		global.TestTemplate.GameInited = true
	end

	-- Every load
	for i, player in pairs(game.players) do
		if player.valid then
			if player.cheat_mode == true then
				player.print("Deconstruct any area to test placeable_by count issue.")				
			end
		end
	end
	script.on_nth_tick(68, nil)	
end

script.on_nth_tick(68, DoRunOnce)

-- ^^^ test template

script.on_event(defines.events.on_player_deconstructed_area,
	function (event)
		log("on_player_deconstructed_area")
		local player = game.players[event.player_index]
		local pos = event.area.left_top
		newEnt = player.surface.create_entity
		{
			name = "entity-ghost",
			inner_name = "placeable-test-entity",
			position = pos,
			force = "player"
		}
   	end
)


