data:extend(
{
  {
    type = "item",
    name = "placeable-test-item",
    icon = "__core__/graphics/factorio-icon.png",
	icon_size = 64, icon_mipmaps = 1,	
    subgroup = "storage",
    order = "yz",
    place_result = "placeable-test-placeholder",
    stack_size = 50,	
  },
  {
    type = "recipe",
    name = "placeable-test-item",
	enabled = true,
    ingredients = { {"wood", 1}	},	
    energy_required = .01,
    result = "placeable-test-item"
  },
  {	
    type = "simple-entity-with-force",
    name = "placeable-test-placeholder",
    icon = "__base__/graphics/icons/dead-grey-trunk.png",
    icon_size = 64, icon_mipmaps = 4,
    flags = {"placeable-player", "placeable-off-grid", "player-creation"}, 
    order = "xy",
    max_health = 200,
    collision_box = {{-0.2, -0.2}, {0.2, 0.2}},
    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},		
    render_layer = "floor",
	picture =
	{
	  filename = "__base__/graphics/entity/tree/dead-grey-trunk/hr-dead-grey-trunk-00.png",
	  width = 217,
	  height = 178,
	  shift = util.by_pixel(29.75, -25),
	  scale = 0.5
	}
  },
  {	
    type = "simple-entity-with-force",
    name = "placeable-test-entity",
	placeable_by = { item = "placeable-test-item", count = 20 },
	
    icon = "__core__/graphics/icons/alerts/logistic-delivery.png",
    icon_size = 64, icon_mipmaps = 1,
    flags = {"placeable-player", "placeable-off-grid", "player-creation"}, 
    order = "zz",
    max_health = 200,
    collision_box = {{-0.2, -0.2}, {0.2, 0.2}},
    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},		
    render_layer = "floor",
	picture =
	  {
		  filename = "__core__/graphics/icons/alerts/logistic-delivery.png",
		  width = 64,
		  height = 64,
		  shift = {0, 0},
		  scale = 0.5
	  }
  }
})
  